* WARNING ! This version could be used with PYTHIA 6.2...
* for usage with TAUOLA_v_2.7 version
*----------------------------------------------------------------------------*
*... author : Serge Slabospitsky 07.12.2005                                  *
*                                                                            *
*     PRETAUOLA_05                                                           *
*                                                                            *
      subroutine pretauola(mode) 
*     --------------------------                                             *
* *** ask for external tau decay generator TAUOLA 
      implicit none
      integer mode
      integer         MDCY,       MDME,                   KFDP
      double precision                         BRAT
      COMMON /PYDAT3/ MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5) ! 6.2
      integer keypol, n11,  n12, ihepDIM, idum, nb11 
      integer            PJAK1, PJAK2, MDTAU 
      common /ki_taumod/ PJAK1, PJAK2, MDTAU 
*
* below L+- means electron/positron or mu+-                                  *
* mdtau = 0      - all decay modes allowed (with account of JAK1 and JAK2)   *
* . . . . . . . . . . . . . . . .  . . . . . . . . . . . . . . . . . . . . . *
* mdtau = 1xx :  could be applied for DIRECT taus (from hard process)        *
* .......                                                                    *
* mdtau = 1   - any taus (DIRECT) according to JAK1 and JAK2                 *
* mdtau = 100 - only L+-  for any tau                                        *
* mdtau = 101 - only e+-  for any tau                                        *
* mdtau = 102 - only mu+- for any tau                                        *
* mdtau = 110 - ONE L+-,  other taus -> all channels                         *
* mdtau = 111 - ONE e+-,  other taus -> all channels                         * 
* mdtau = 112 - ONE mu+-, other taus -> all channels                         *
* mdtau = 114 - ONE L+-,  other taus -> hadrons                              *
* mdtau = 115 - ONE e+-,  other taus -> hadrons                              *
* mdtau = 116 - ONE mu+-, other taus -> hadrons                              *
* mdtau = 120 - TWO L+-,  other taus -> all channels                         *
* mdtau = 121 - TWO e+-,  other taus -> all channels                         *
* mdtau = 122 - TWO mu+-, other taus -> all channels                         *
* mdtau = 123 - ONE e+-, SECOND mu+-, other taus -> all channels             * 
* mdtau = 124 - TWO L+-,  other taus -> hadrons                              *
* mdtau = 125 - TWO e+-,  other taus -> hadrons                              *
* mdtau = 126 - TWO mu+-, other taus -> hadrons                              *
* mdtau = 127 - ONE e+-, SECOND mu+-, other taus -> hadrons                  *
* mdtau = 130 - only hadronic channels for any tau                           *
* mdtau = 131 - ONE tau  -> hadrons, other taus -> all channels              *
* mdtau = 132 - TWO taus -> hadrons, other taus -> all channels              *
* mdtau = 140 - only nutau and PI+-    for any tau                           *
* mdtau = 141 - ONE tau -> PI+-, other taus -> all channels                  *
* mdtau = 142 - TWO tau -> PI+-, other taus -> all channels                  *
*----------------------------------------------------------------------------*
* mdtau = 2xx   :  could be applied for any taus                             *
* .......                                                                    *
* mdtau = 200 - only L+-  for any tau                                        *
* mdtau = 201 - only e+-  for any tau                                        *
* mdtau = 202 - only mu+- for any tau                                        *
* mdtau = 210 - ONE L+-,  other taus -> all channels                         *
* mdtau = 211 - ONE e+-,  other taus -> all channels                         * 
* mdtau = 212 - ONE mu+-, other taus -> all channels                         *
* mdtau = 214 - ONE L+-,  other taus -> hadrons                              *
* mdtau = 215 - ONE e+-,  other taus -> hadrons                              *
* mdtau = 216 - ONE mu+-, other taus -> hadrons                              *
* mdtau = 220 - TWO L+-,  other taus -> all channels                         *
* mdtau = 221 - TWO e+-,  other taus -> all channels                         *
* mdtau = 222 - TWO mu+-, other taus -> all channels                         *
* mdtau = 223 - ONE e+-, SECOND mu+-, other taus -> all channels             * 
* mdtau = 224 - TWO L+-,  other taus -> hadrons                              *
* mdtau = 225 - TWO e+-,  other taus -> hadrons                              *
* mdtau = 226 - TWO mu+-, other taus -> hadrons                              *
* mdtau = 227 - ONE e+-, SECOND mu+-, other taus -> hadrons                  *
* mdtau = 230 - only hadronic channels for any tau                           *
* mdtau = 231 - ONE tau  -> hadons, other taus -> all channels               *
* mdtau = 232 - TWO taus -> hadons, other taus -> all channels               *
* mdtau = 240 - only nutau and PI+-    for any tau                           *
* mdtau = 241 - ONE tau -> PI+-, other taus -> all channels                  *
* mdtau = 242 - TWO tau -> PI+-, other taus -> all channels                  *
* . . . . . 
* if the event has only ONE tau-lepton the cases with TWO requirements
* the both two required channels are considered simultaneously
*

      if(mdtau.le.-1) return
      if(mode.eq.-1) then
* initialisation 
*         mstj(28) = 2
         mdcy(15,1) = 0 !!! suppress tau-lepton decays by PYTHIA 
*
         KEYPOL=1
*
         call taurep(-2)
*
         CALL TAUOLA_SRS(-1,KEYPOL) 
      elseif(mode.eq.0) then 
* running
         CALL PYHEPC_T(1)         ! PYJETS ==> HEPEVT
         n11 = ihepdim(idum)      ! no of entries in hepevt before tauola
         CALL TAUOLA_SRS(0,KEYPOL) 
         n12 = ihepdim(idum)      ! no of entries in hepevt after tauola
         if (n12.gt.n11) then
          call PYHEPC_T(2)        ! HEPEVT ==> PYJETS
*          call reports(n11, n12)
          nb11 = n11
          call furvrtx(nb11,n12)      ! set production vertex
          call furdec(n11, n12)   ! call PYDECY to decay unstable hadrons 
                                  ! resulted from TAUOLA
          endif
      elseif(mode.eq.1) then 
* closing
      CALL TAUOLA_SRS(1,KEYPOL) 
**
      endif
      RETURN
      END
