

*----------------------------------------------------------------------------*
* author:   Serge Slabospitsky  30.09.03                                     *
* below L+- means electron/positron or mu+-                                  *
* mdtau = 0      - all decay modes allowed (with account of JAK1 and JAK2)   *
* . . . . . . . . . . . . . . . .  . . . . . . . . . . . . . . . . . . . . . *
* mdtau = 1xx :  could be applied for DIRECT taus (from hard process)        *
* .......                                                                    *
* mdtau = 1   - any taus (DIRECT) according to JAK1 and JAK2                 *
* mdtau = 100 - only L+-  for any tau                                        *
* mdtau = 101 - only e+-  for any tau                                        *
* mdtau = 102 - only mu+- for any tau                                        *
* mdtau = 110 - ONE L+-,  other taus -> all channels                         *
* mdtau = 111 - ONE e+-,  other taus -> all channels                         * 
* mdtau = 112 - ONE mu+-, other taus -> all channels                         *
* mdtau = 114 - ONE L+-,  other taus -> hadrons                              *
* mdtau = 115 - ONE e+-,  other taus -> hadrons                              *
* mdtau = 116 - ONE mu+-, other taus -> hadrons                              *
* mdtau = 120 - TWO L+-,  other taus -> all channels                         *
* mdtau = 121 - TWO e+-,  other taus -> all channels                         *
* mdtau = 122 - TWO mu+-, other taus -> all channels                         *
* mdtau = 123 - ONE e+-, SECOND mu+-, other taus -> all channels             * 
* mdtau = 124 - TWO L+-,  other taus -> hadrons                              *
* mdtau = 125 - TWO e+-,  other taus -> hadrons                              *
* mdtau = 126 - TWO mu+-, other taus -> hadrons                              *
* mdtau = 127 - ONE e+-, SECOND mu+-, other taus -> hadrons                  *
* mdtau = 130 - only hadronic channels for any tau                           *
* mdtau = 131 - ONE tau  -> hadrons, other taus -> all channels              *
* mdtau = 132 - TWO taus -> hadrons, other taus -> all channels              *
* mdtau = 140 - only nutau and PI+-    for any tau                           *
* mdtau = 141 - ONE tau -> PI+-, other taus -> all channels                  *
* mdtau = 142 - TWO tau -> PI+-, other taus -> all channels                  *
*----------------------------------------------------------------------------*
* mdtau = 2xx   :  could be applied for any taus                             *
* .......                                                                    *
* mdtau = 200 - only L+-  for any tau                                        *
* mdtau = 201 - only e+-  for any tau                                        *
* mdtau = 202 - only mu+- for any tau                                        *
* mdtau = 210 - ONE L+-,  other taus -> all channels                         *
* mdtau = 211 - ONE e+-,  other taus -> all channels                         * 
* mdtau = 212 - ONE mu+-, other taus -> all channels                         *
* mdtau = 214 - ONE L+-,  other taus -> hadrons                              *
* mdtau = 215 - ONE e+-,  other taus -> hadrons                              *
* mdtau = 216 - ONE mu+-, other taus -> hadrons                              *
* mdtau = 220 - TWO L+-,  other taus -> all channels                         *
* mdtau = 221 - TWO e+-,  other taus -> all channels                         *
* mdtau = 222 - TWO mu+-, other taus -> all channels                         *
* mdtau = 223 - ONE e+-, SECOND mu+-, other taus -> all channels             * 
* mdtau = 224 - TWO L+-,  other taus -> hadrons                              *
* mdtau = 225 - TWO e+-,  other taus -> hadrons                              *
* mdtau = 226 - TWO mu+-, other taus -> hadrons                              *
* mdtau = 227 - ONE e+-, SECOND mu+-, other taus -> hadrons                  *
* mdtau = 230 - only hadronic channels for any tau                           *
* mdtau = 231 - ONE tau  -> hadons, other taus -> all channels               *
* mdtau = 232 - TWO taus -> hadons, other taus -> all channels               *
* mdtau = 240 - only nutau and PI+-    for any tau                           *
* mdtau = 241 - ONE tau -> PI+-, other taus -> all channels                  *
* mdtau = 242 - TWO tau -> PI+-, other taus -> all channels                  *
* . . . . . 
* if the event has only ONE tau-lepton the cases with TWO requirements
* the both two required channels are considered simultaneously
*

      SUBROUTINE  TAUDEC
      implicit none
      integer NCHAN, JLIST
      real GAMPRT
      COMMON / TAUBRA / GAMPRT(30),JLIST(30),NCHAN
      double precision PYR, CURBRA 
      common /finbra/ curBRA 
      SAVE /finbra/ 
      integer ntaumax
      parameter  (ntaumax=50)
      integer ntaus,   ltaus
      common  /taulist/ ntaus, ltaus(ntaumax,3)
      integer            PJAK1, PJAK2, MDTAU 
      integer ndir, idir, ldir(ntaumax) 
      common /ki_taumod/ PJAK1, PJAK2, MDTAU 
*      integer PJAK1, PJAK2 
*      common /pretaul/ PJAK1, PJAK2
*      integer mdtau      
*      common /taudmod/ mdtau
      integer ITAUMDE, itau, ist1, ist2, KFTAU 
      data KFTAU/15/  ! tau- 
      double precision brALL, brLEP, brHAD, brnonEL, brnonMU 
      common /brcum/ brALL, brLEP, brHAD, brnonEL, brnonMU
      integer ITLDRC 
*---
      curBRA = 0.d0
      IF(ntaus.le.0) return
      IF(mdtau.eq.0) THEN   ! all decay modes allowed
       curBRA = 1.d0
       do itau = 1, Ntaus
         If(ltaus(itau,2).eq.-KFTAU) Then  ! tau+
          if(PJAK1.ge.1) then
            ltaus(itau,3) = pjak1
            curBRA = curBRA * gamprt(pjak1) 
          else
            ltaus(itau,3) = ITAUMDE(0) 
            curBRA = curBRA * brALL
          endif
         Elseif(ltaus(itau,2).eq.KFTAU) Then ! tau-
          If(PJAK2.ge.1) then
            ltaus(itau,3) = pjak2
            curBRA = curBRA * gamprt(pjak2) 
         else
            ltaus(itau,3) = ITAUMDE(0) 
            curBRA = curBRA * brALL
         endif
        Else
          ltaus(itau,3) = -1 ! something wrong with KF of tau candidate
          print*,'wrong KF(tau candidate) = ',ltaus(itau,2),
     *   ' for N(tau) ',itau
        EndIf 
       enddo
*       do itau = 1, Ntaus
*         if(ltaus(itau,2).eq.-KFTAU.and.PJAK1.ge.1) then
*            ltaus(itau,3) = pjak1
*            curBRA = curBRA * gamprt(pjak1) 
*         else
*            ltaus(itau,3) = ITAUMDE(0) 
*            curBRA = curBRA * brALL
*         endif
*
*         if(ltaus(itau,2).eq.KFTAU.and.PJAK2.ge.1) then
*            ltaus(itau,3) = pjak2
*            curBRA = curBRA * gamprt(pjak2) 
*         else
*            ltaus(itau,3) = ITAUMDE(0) 
*            curBRA = curBRA * brALL
*         endif
*       enddo
      RETURN
      ENDIF      
*  
* firtsly we set any decay channel for any tau and mark 'direct' tau
*
       ndir = 0
       do itau = 1, Ntaus
        ltaus(itau,3) = itauMDE(0)
          if(ITLDRC(ltaus(itau,1)).eq.+1) then
            ndir = ndir + 1
            ldir(ndir) = itau
          endif
       enddo    
         curBRA = 1.d0
* DIRECT tau-leptons (from hard process)
       IF(MDTAU.eq.1) THEN ! taus decays according to JAKS
       curBRA = 1.d0
       do idir = 1, Ndir
         if(ltaus(ldir(idir),2).eq.-KFTAU.and.PJAK1.ge.1) then
            ltaus(ldir(idir),3) = pjak1
            curBRA = curBRA * gamprt(pjak1) 
         else
            ltaus(ldir(idir),3) = ITAUMDE(0) 
            curBRA = curBRA * brALL
         endif
*
         if(ltaus(ldir(idir),2).eq.KFTAU.and.PJAK2.ge.1) then
            ltaus(ldir(idir),3) = pjak2
            curBRA = curBRA * gamprt(pjak2) 
         else
            ltaus(ldir(idir),3) = ITAUMDE(0) 
            curBRA = curBRA * brALL
         endif
       enddo
      ELSEIF(mdtau.eq.100) THEN      ! only L+-  for any tau 
       curBRA = 1.d0
       do itau = 1, Ntaus
         if(ITLDRC(ltaus(itau,1)).eq.+1) then
           ltaus(itau,3) = itauMDE(100)
           curBRA = curBRA * brLEP 
         endif
       enddo
*
      ELSEIF(mdtau.eq.101) THEN      ! only e+-  for any tau 
       curBRA = 1.d0
       do itau = 1, Ntaus
         if(ITLDRC(ltaus(itau,1)).eq.+1) then
           ltaus(itau,3) = 1 
           curBRA = curBRA * gamprt(1) 
         endif
       enddo
*
      ELSEIF(mdtau.eq.102) THEN      ! only mu+-  for any tau 
       curBRA = 1.d0
       do itau = 1, Ntaus
         if(ITLDRC(ltaus(itau,1)).eq.+1) then
           ltaus(itau,3) = 2 
           curBRA = curBRA * gamprt(2) 
         endif
       enddo
*
      ELSEIF(mdtau.eq.110) THEN             ! ONE L+- 
       curBRA = 1.d0                        ! other taus -> all channels 
       if(Ndir.eq.1) then
         ltaus(ldir(1), 3) = itauMDE(100)   ! L+- mode
         curBRA = brLEP 
       elseif(ndir.ge.2) then
         ist1 = (ndir * pyr(0)) + 1
         ltaus(ldir(ist1),3) = itauMDE(100) ! L+- mode
         curBRA = brLEP 
       endif
*
      ELSEIF(mdtau.eq.111) THEN             ! ONE e+-
       curBRA = 1.d0                        ! other taus -> all channels 
       if(Ndir.eq.1) then
         ltaus(ldir(1), 3) = 1              ! e+- mode
         curBRA = gamprt(1) 
       elseif(ndir.ge.2) then
         ist1 = (ndir * pyr(0)) + 1
         ltaus(ldir(ist1),3) = 1            ! e+- mode
         curBRA = gamprt(1)
       endif
*
      ELSEIF(mdtau.eq.112) THEN             ! ONE mu+-
       curBRA = 1.d0                        ! other taus -> all channels 
       if(Ndir.eq.1) then
         ltaus(ldir(1), 3) = 2              ! mu+- mode
         curBRA = gamprt(2) 
       elseif(ndir.ge.2) then
         ist1 = (ndir * pyr(0)) + 1
         ltaus(ldir(ist1),3) = 2            ! mu+- mode
         curBRA = gamprt(2)
       endif
*
      ELSEIF(mdtau.eq.114) THEN    ! ONE tau -> L+- 
                                   ! other taus -> hadrons 
      curBRA = 1.d0   
       iF(Ndir.eq.1) then
          ltaus(ldir(1), 3) = itauMDE(100) 
          curBRA = brLEP 
       elSEIF(Ndir.ge.2) then
         ist1 = ( ndir    * pyr(0)) + 1
         ltaus(ldir(ist1),3) = itauMDE(100)      ! lepton channel   
         curBRA = brLEP
          do idir = 1, ndir 
            if(idir.ne.ist1) then
              ltaus(ldir(idir),3) = itauMDE(200) 
              curBRA = curBRA * brHAD 
            endif
          enddo
      endIF
*
      ELSEIF(mdtau.eq.115) THEN    ! ONE tau -> e+- 
                                   ! other taus -> hadrons 
      curBRA = 1.d0   
       iF(Ndir.eq.1) then
          ltaus(ldir(1), 3) = 1
          curBRA = gamprt(1) 
       elSEIF(Ndir.ge.2) then
         ist1 = ( ndir    * pyr(0)) + 1
         ltaus(ldir(ist1),3) = 1   ! e+- channel   
         curBRA = gamprt(1) 
          do idir = 1, ndir 
            if(idir.ne.ist1) then
              ltaus(ldir(idir),3) = itauMDE(200) 
              curBRA = curBRA * brHAD 
            endif
          enddo
      endIF
*
      ELSEIF(mdtau.eq.116) THEN    ! ONE tau -> mu+- 
                                   ! other taus -> hadrons 
      curBRA = 1.d0   
       iF(Ndir.eq.1) then
          ltaus(ldir(1), 3) = 2
          curBRA = gamprt(2) 
       elSEIF(Ndir.ge.2) then
         ist1 = ( ndir    * pyr(0)) + 1
         ltaus(ldir(ist1),3) = 2   ! mu+- channel   
         curBRA = gamprt(2) 
          do idir = 1, ndir 
            if(idir.ne.ist1) then
              ltaus(ldir(idir),3) = itauMDE(200) 
              curBRA = curBRA * brHAD 
            endif
          enddo
      endIF
*
      ELSEIF(mdtau.eq.120) THEN   ! TWO L+- 
       curBRA = 1.d0              ! other taus -> all channels 
       if(Ndir.eq.1) then
         ltaus(ldir(1),3) = itauMDE(100)
         curBRA = brLEP
       elseif(Ndir.eq.2) then
         ltaus(ldir(1),3) = itauMDE(100)
         ltaus(ldir(2),3) = itauMDE(100)
          curBRA = brLEP**2
                              elseif(Ndir.ge.3) then
        ist1 = ( ndir    * pyr(0)) + 1
        ist2 = ((ndir-1) * pyr(0)) + 1 
        if(ist2.eq.ist1) ist2 = ist2 + 1
       ltaus(ldir(ist1),3) = itauMDE(100)
       ltaus(ldir(ist2),3) = itauMDE(100)
         curBRA = brLEP**2 
      endif
*
      ELSEIF(mdtau.eq.121) THEN      ! TWO e+- 
       curBRA = 1.d0                 ! other taus -> all channels 
       if(Ndir.eq.1) then
         ltaus(ldir(1),3) = 1        ! electron mode
         curBRA = gamprt(1)
       elseif(Ndir.eq.2) then
         ltaus(ldir(1),3) = 1        ! electron mode
         ltaus(ldir(2),3) = 1        ! electron mode
         curBRA = gamprt(1)**2
       elseif(Ndir.ge.3) then
         ist1 = ( ndir    * pyr(0)) + 1
         ist2 = ((ndir-1) * pyr(0)) + 1 
         if(ist2.eq.ist1) ist2 = ist2 + 1
        ltaus(ldir(ist1),3) = 1              ! electron mode
        ltaus(ldir(ist2),3) = 1              ! electron mode
        curBRA = gamprt(1)**2 
       endif
*
      ELSEIF(mdtau.eq.122) THEN      ! TWO mu+- 
       curBRA = 1.d0                 ! other taus -> all channels 
       if(Ndir.eq.1) then
         ltaus(ldir(1),3) = 2        ! muon channel
         curBRA = gamprt(2)
       elseif(Ndir.eq.2) then
         ltaus(ldir(1),3) = 2        ! muon channel
         ltaus(ldir(2),3) = 2        ! muon channel
         curBRA = gamprt(2)**2
       elseif(Ndir.ge.3) then
         ist1 = ( ndir    * pyr(0)) + 1
         ist2 = ((ndir-1) * pyr(0)) + 1 
         if(ist2.eq.ist1) ist2 = ist2 + 1
        ltaus(ldir(ist1),3) = 2              ! muon mode
        ltaus(ldir(ist2),3) = 2              ! muon mode
        curBRA = gamprt(2)**2 
       endif
*
      ELSEIF(mdtau.eq.123) THEN    ! ONE tau -> e+-, SECOND tau --> mu+-   
                                   ! other taus -> all channels 
       if(Ndir.eq.0)     then
         curBRA = 1.d0 
       elseif(Ndir.eq.1) then
         ltaus(ldir(1), 3) = itauMDE(100)      ! lepton  mode
         curBRA = brLEP
       elseif(ndir.eq.2) then
         ltaus(ldir(1), 3) = itauMDE(100)      ! lepton  mode
         ltaus(ldir(2), 3) = 3 - ltaus(ldir(1), 3)
         curBRA = gamprt(1) * gamprt(2) 
       elseif(Ndir.ge.3) then
         ist1 = ( ndir    * pyr(0)) + 1
         ist2 = ((ndir-1) * pyr(0)) + 1 
         if(ist2.eq.ist1) ist2 = ist2 + 1
        ltaus(ldir(ist1), 3) = itauMDE(100)
        ltaus(ldir(ist2), 3) = 3 - ltaus(ldir(ist1), 3)
        curBRA = gamprt(1) * gamprt(2) 
       endif
*
      ELSEIF(mdtau.eq.124) THEN    ! TWO tau -> L+-, 
                                   ! other taus -> hadrons 
       if(Ndir.eq.0)     then
         curBRA = 1.d0 
       elseif(Ndir.eq.1) then
         ltaus(ldir(1), 3) = itauMDE(100)      ! lepton  mode
         curBRA = brLEP
       elseif(ndir.ge.2) then
        ist1 = ( ndir    * pyr(0)) + 1
        ist2 = ((ndir-1) * pyr(0)) + 1 
        if(ist2.eq.ist1) ist2 = ist2 + 1
       ltaus(ldir(ist1),3) = itauMDE(100)
       ltaus(ldir(ist2),3) = itauMDE(100)
         curBRA = brLEP**2 
         do idir = 1, Ndir
          if(idir.ne.ist1.AND.idir.ne.ist2) then
            ltaus(ldir(idir),3) = itauMDE(200) 
            curBRA = curBRA * brHAD 
          endif
         enddo 
       endif
*
      ELSEIF(mdtau.eq.125) THEN    ! TWO tau -> e+-, 
                                   ! other taus -> hadrons 
       if(Ndir.eq.0)     then
         curBRA = 1.d0 
       elseif(Ndir.eq.1) then
         ltaus(ldir(1), 3) = 1     ! e+- 
         curBRA = gamprt(1)
       elseif(ndir.ge.2) then
        ist1 = ( ndir    * pyr(0)) + 1
        ist2 = ((ndir-1) * pyr(0)) + 1 
        if(ist2.eq.ist1) ist2 = ist2 + 1
       ltaus(ldir(ist1),3) = 1
       ltaus(ldir(ist2),3) = 1
         curBRA = gamprt(1)**2 
         do idir = 1, Ndir
          if(idir.ne.ist1.AND.idir.ne.ist2) then
            ltaus(ldir(idir),3) = itauMDE(200) 
            curBRA = curBRA * brHAD 
          endif
         enddo 
       endif
*
      ELSEIF(mdtau.eq.126) THEN    ! TWO tau -> mu+-, 
                                   ! other taus -> hadrons 
       if(Ndir.eq.0)     then
         curBRA = 1.d0 
       elseif(Ndir.eq.1) then
         ltaus(ldir(1), 3) = 2     ! mu+- 
         curBRA = gamprt(2)
       elseif(ndir.ge.2) then
        ist1 = ( ndir    * pyr(0)) + 1
        ist2 = ((ndir-1) * pyr(0)) + 1 
        if(ist2.eq.ist1) ist2 = ist2 + 1
       ltaus(ldir(ist1),3) = 2
       ltaus(ldir(ist2),3) = 2
         curBRA = gamprt(2)**2 
         do idir = 1, Ndir
          if(idir.ne.ist1.AND.idir.ne.ist2) then
            ltaus(ldir(idir),3) = itauMDE(200) 
            curBRA = curBRA * brHAD 
          endif
         enddo 
       endif
*
      ELSEIF(mdtau.eq.127) THEN    ! ONE tau -> e+-, SECOND tau --> mu+-   
                                   ! other taus -> hadrons 
       if(Ndir.eq.0)     then
         curBRA = 1.d0 
       elseif(Ndir.eq.1) then
         ltaus(ldir(1), 3) = itauMDE(100)      ! lepton  mode
         curBRA = brLEP
       elseif(Ndir.eq.2) then
         ltaus(ldir(1), 3) = itauMDE(100)      ! lepton  mode
         ltaus(ldir(2), 3) = 3 - ltaus(ldir(1), 3)
         curBRA = gamprt(1) * gamprt(2) 
       elseif(Ndir.ge.3) then
        ist1 = ( ndir    * pyr(0)) + 1
        ist2 = ((ndir-1) * pyr(0)) + 1 
        if(ist2.eq.ist1) ist2 = ist2 + 1
       ltaus(ldir(ist1),3) = itauMDE(100) 
       ltaus(ldir(ist2),3) = 3 - ltaus(ldir(ist1), 3) 
         curBRA = gamprt(1) * gamprt(2) 
         do idir = 1, Ndir
          if(idir.ne.ist1.AND.idir.ne.ist2) then
            ltaus(ldir(idir),3) = itauMDE(200) 
            curBRA = curBRA * brHAD 
          endif
         enddo 
       endif
*
      ELSEIF(mdtau.eq.130) THEN   ! only hadronic modes for any direct tau 
       curBRA = 1.d0
       do idir = 1, Ndir
        ltaus(ldir(idir),3) = itauMDE(200) 
        curBRA = curBRA * brHAD
       enddo
*
      ELSEIF(mdtau.eq.131) THEN    ! ONE tau -> hadrons 
       curBRA = 1.d0               ! other taus -> all channels
       if(Ndir.eq.1) then
         ltaus(ldir(1),3) = itauMDE(200)
         curBRA = brHAD
       elseif(Ndir.ge.2) then
        ist1 = ( ndir    * pyr(0)) + 1
        ltaus(ldir(ist1),3) = itauMDE(200)
        curBRA = brHAD
      endif
*
      ELSEIF(mdtau.eq.132) THEN    ! TWO taus -> hadrons 
       curBRA = 1.d0               ! other taus -> all channels
       if(Ndir.eq.1) then
          ltaus(ldir(1),3) = itauMDE(200)
          curBRA = brHAD
       elseif(Ndir.eq.2) then
          ltaus(ldir(1),3) = itauMDE(200)
          ltaus(ldir(2),3) = itauMDE(200)
          curBRA = brHAD**2
       elseif(ndir.ge.3) then
        ist1 = ( ndir    * pyr(0)) + 1
        ist2 = ((ndir-1) * pyr(0)) + 1 
        if(ist2.eq.ist1) ist2 = ist2 + 1
        ltaus(ldir(ist1),3) = itauMDE(200)
        ltaus(ldir(ist2),3) = itauMDE(200)
        curBRA = brHAD**2 
      endif
*
      ELSEIF(mdtau.eq.140) THEN      ! only (nutau + PI+-) for any tau 
       curBRA = 1.d0
       do idir = 1, Ndir 
        ltaus(ldir(idir),3) = 3 
        curBRA = curBRA * gamprt(3)
       enddo
*
      ELSEIF(mdtau.eq.141) THEN      ! ONE tau -> (nutau + PI+-) 
       curBRA = 1.d0                 ! other taus -> all channels
       if(Ndir.eq.1) then
         ltaus(ldir(1),3) = 3
         curBRA = gamprt(3) 
       elseif(Ndir.ge.2) then
         ist1 = ( ndir    * pyr(0)) + 1
         ltaus(ldir(ist1),3) = 3
         curBRA = gamprt(3)
      endif
*
      ELSEIF(mdtau.eq.142) THEN     ! TWO taus -> (nutau + PI+-)taus
       curBRA = 1.d0                ! other taus -> all channels
       if(Ndir.eq.1) then
         ltaus(ldir(1),3) = 3
         curBRA = gamprt(3)
       elseif(Ndir.eq.2) then
         ltaus(ldir(1),3) = 3
         ltaus(ldir(2),3) = 3
         curBRA = gamprt(3)**2
       elseif(Ndir.ge.3) then
         ist1 = ( ndir    * pyr(0)) + 1
         ist2 = ((ndir-1) * pyr(0)) + 1 
         if(ist2.eq.ist1) ist2 = ist2 + 1
         ltaus(ldir(ist1),3) = 3
         ltaus(ldir(ist2),3) = 3
         curBRA = gamprt(3)**2
      endif
*
*-----------  for ALL taus -------------
      ELSEIF(mdtau.eq.200) THEN      ! only L+-  for any tau 
       curBRA = 1.d0
       do itau = 1, Ntaus
        ltaus(itau,3) = itauMDE(100)
        curBRA = curBRA * brLEP
       enddo
*
      ELSEIF(mdtau.eq.201) THEN      ! only e+-  for any tau 
       do itau = 1, Ntaus
        ltaus(itau,3) = 1             ! electron mode
       enddo
       curBRA = gamprt(1)**Ntaus
*
      ELSEIF(mdtau.eq.202) THEN   ! only mu+- for any tau 
       do itau = 1, Ntaus
        ltaus(itau,3) = 2          ! muon  mode
       enddo
       curBRA = gamprt(2) ** Ntaus
*
      ELSEIF(mdtau.eq.210) THEN             ! ONE L+- 
       curBRA = 1.d0                        ! other taus -> all channels 
       if(Ntaus.eq.1) then
         ltaus(1, 3) = itauMDE(100)   ! L+- mode
         curBRA = brLEP 
       elseif(ntaus.ge.2) then
         ist1 = (ntaus * pyr(0)) + 1
         ltaus(ist1,3) = itauMDE(100) ! L+- mode
         curBRA = brLEP 
       endif
*
      ELSEIF(mdtau.eq.211) THEN       ! ONE e+-
       curBRA = 1.d0                  ! other taus -> all channels 
       if(Ntaus.eq.1) then
        ltaus(1, 3) = 1               ! electron mode
        curBRA = gamprt(1) 
       elseif(Ntaus.ge.2) then
        ist1 = (ntaus * pyr(0)) + 1
        ltaus(ist1,3) = 1             ! electron  mode
        curBRA = gamprt(1) 
      endif
*
      ELSEIF(mdtau.eq.212) THEN     ! at least ONE mu+-
                                    ! and all channels for other taus
       if(Ntaus.eq.1) then
        ltaus(1, 3) = 2             ! muon mode
        curBRA = gamprt(2) 
       elseif(Ntaus.ge.2) then
        ist1 = (ntaus * pyr(0)) + 1
        ltaus(ist1,3) = 2           ! muon  mode
        curBRA = gamprt(2) 
       endif
*
      ELSEIF(mdtau.eq.214) THEN    ! ONE tau -> L+- 
                                   ! other taus -> hadrons 
      curBRA = 1.d0   
       iF(Ntaus.eq.1) then
          ltaus(1, 3) = itauMDE(100) 
          curBRA = brLEP 
       elSEIF(Ntaus.ge.2) then
         ist1 = ( ntaus    * pyr(0)) + 1
         ltaus(ist1,3) = itauMDE(100)      ! lepton channel   
         curBRA = brLEP
          do idir = 1, Ntaus
            if(idir.ne.ist1) then
              ltaus(idir,3) = itauMDE(200) 
              curBRA = curBRA * brHAD 
            endif
          enddo
      endIF
*
      ELSEIF(mdtau.eq.215) THEN    ! ONE tau -> e+- 
                                   ! other taus -> hadrons 
      curBRA = 1.d0   
       iF(Ntaus.eq.1) then
         ltaus(1, 3) = 1
         curBRA = gamprt(1) 
       elSEIF(Ntaus.ge.2) then
         ist1 = ( ntaus    * pyr(0)) + 1
         ltaus(ist1,3) = 1         ! e+- channel
         curBRA = gamprt(1) 
          do idir = 1, Ntaus
            if(idir.ne.ist1) then
              ltaus(idir,3) = itauMDE(200) 
              curBRA = curBRA * brHAD 
            endif
          enddo
      endIF
*
      ELSEIF(mdtau.eq.216) THEN    ! ONE tau -> mu+- 
                                   ! other taus -> hadrons 
      curBRA = 1.d0   
       iF(Ntaus.eq.1) then
         ltaus(1, 3) = 2
         curBRA = gamprt(2) 
       elSEIF(Ntaus.ge.2) then
         ist1 = ( ntaus    * pyr(0)) + 1
         ltaus(ist1,3) = 2         ! mu+- channel
         curBRA = gamprt(2) 
          do idir = 1, Ntaus
            if(idir.ne.ist1) then
              ltaus(idir,3) = itauMDE(200) 
              curBRA = curBRA * brHAD 
            endif
          enddo
      endIF
*
      ELSEIF(mdtau.eq.220) THEN   ! TWO L+- 
       curBRA = 1.d0              ! other taus -> all channels 
       if(Ntaus.eq.1) then
         ltaus(1,3) = itauMDE(100)
         curBRA = brLEP
       elseif(Ntaus.eq.2) then
         ltaus(1,3) = itauMDE(100)
         ltaus(2,3) = itauMDE(100)
          curBRA = brLEP**2
       elseif(Ntaus.ge.3) then
        ist1 = ( Ntaus    * pyr(0)) + 1
        ist2 = ((Ntaus-1) * pyr(0)) + 1 
        if(ist2.eq.ist1) ist2 = ist2 + 1
       ltaus(ist1,3) = itauMDE(100)
       ltaus(ist2,3) = itauMDE(100)
         curBRA = brLEP**2 
      endif
*
      ELSEIF(mdtau.eq.221) THEN   ! at least TWO e+- 
       curBRA = 1.d0              ! other taus -> all channels 
       if(Ntaus.eq.1) then
         ltaus(1,3) = 1
         curBRA = gamprt(1)
       elseif(Ntaus.eq.2) then
         ltaus(1,3) = 1
         ltaus(2,3) = 1
          curBRA = gamprt(1)**2
       elseif(Ntaus.ge.3) then
         ist1 = ( ntaus    * pyr(0)) + 1
         ist2 = ((ntaus-1) * pyr(0)) + 1 
         if(ist2.eq.ist1) ist2 = ist2 + 1
         ltaus(ist1,3) = 1                        ! electron mode
         ltaus(ist2,3) = 1                        ! electron mode
         curBRA = gamprt(1)**2 
       endif
*
      ELSEIF(mdtau.eq.222) THEN   ! at least TWO mu+- 
       curBRA = 1.d0              ! other taus -> all channels 
       if(Ntaus.eq.1) then
         ltaus(1,3) = 2
         curBRA = gamprt(2)
       elseif(Ntaus.eq.2) then
         ltaus(1,3) = 2
         ltaus(2,3) = 2
          curBRA = gamprt(2)**2
       elseif(Ntaus.ge.3) then
         ist1 = ( ntaus    * pyr(0)) + 1
         ist2 = ((ntaus-1) * pyr(0)) + 1 
         if(ist2.eq.ist1) ist2 = ist2 + 1
         ltaus(ist1,3) = 2 
         ltaus(ist2,3) = 2 
         curBRA = gamprt(2)**2 
       endif
*
      ELSEIF(mdtau.eq.223) THEN    ! ONE tau -> e+-, SECOND tau --> mu+-   
                                   ! other taus -> all channels 
       if(Ntaus.eq.0)     then
         curBRA = 1.d0 
       elseif(Ntaus.eq.1) then
         ltaus(1, 3) = itauMDE(100)      ! lepton  mode
         curBRA = brLEP
       elseif(Ntaus.eq.2) then
         ltaus(1, 3) = itauMDE(100)      ! lepton  mode
         ltaus(2, 3) = 3 - ltaus(1, 3)
         curBRA = gamprt(1) * gamprt(2) 
       elseif(Ndir.ge.3) then
         ist1 = ( Ntaus    * pyr(0)) + 1
         ist2 = ((Ntaus-1) * pyr(0)) + 1 
         if(ist2.eq.ist1) ist2 = ist2 + 1
        ltaus(ist1, 3) = itauMDE(100)
        ltaus(ist2, 3) = 3 - ltaus(ist1, 3)
        curBRA = gamprt(1) * gamprt(2) 
       endif
*
      ELSEIF(mdtau.eq.224) THEN    ! TWO tau -> L+-, 
                                   ! other taus -> hadrons 
       if(Ntaus.eq.1) then
         ltaus(1, 3) = itauMDE(100)      ! lepton  mode
         curBRA = brLEP
       elseif(Ntaus.ge.2) then
        ist1 = ( Ntaus    * pyr(0)) + 1
        ist2 = ((Ntaus-1) * pyr(0)) + 1 
        if(ist2.eq.ist1) ist2 = ist2 + 1
       ltaus(ist1,3) = itauMDE(100)
       ltaus(ist2,3) = itauMDE(100)
         curBRA = brLEP**2 
         do idir = 1, Ntaus
          if(idir.ne.ist1.AND.idir.ne.ist2) then
            ltaus(idir,3) = itauMDE(200) 
            curBRA = curBRA * brHAD 
          endif
         enddo 
       endif
*
      ELSEIF(mdtau.eq.225) THEN    ! TWO tau -> e+-, 
                                   ! other taus -> hadrons 
       if(Ntaus.eq.1) then
         ltaus(1, 3) = 1   ! lepton  mode
         curBRA = gamprt(1)
       elseif(Ntaus.ge.2) then
        ist1 = ( Ntaus    * pyr(0)) + 1
        ist2 = ((Ntaus-1) * pyr(0)) + 1 
        if(ist2.eq.ist1) ist2 = ist2 + 1
       ltaus(ist1,3) = 1
       ltaus(ist2,3) = 1
         curBRA = gamprt(1)**2 
         do idir = 1, Ntaus
          if(idir.ne.ist1.AND.idir.ne.ist2) then
            ltaus(idir,3) = itauMDE(200) 
            curBRA = curBRA * brHAD 
          endif
         enddo 
       endif
*
      ELSEIF(mdtau.eq.226) THEN    ! TWO tau -> mu+-, 
                                   ! other taus -> hadrons 
       if(Ntaus.eq.1) then
         ltaus(1, 3) = 2   ! lepton  mode
         curBRA = gamprt(2)
       elseif(Ntaus.ge.2) then
        ist1 = ( Ntaus    * pyr(0)) + 1
        ist2 = ((Ntaus-1) * pyr(0)) + 1 
        if(ist2.eq.ist1) ist2 = ist2 + 1
       ltaus(ist1,3) = 2
       ltaus(ist2,3) = 2
         curBRA = gamprt(2)**2 
         do idir = 1, Ntaus
          if(idir.ne.ist1.AND.idir.ne.ist2) then
            ltaus(idir,3) = itauMDE(200) 
            curBRA = curBRA * brHAD 
          endif
         enddo 
       endif
*
      ELSEIF(mdtau.eq.227) THEN    ! ONE tau -> e+-, SECOND tau --> mu+-   
                                   ! other taus -> hadrons 
       if(Ntaus.eq.0)     then
         curBRA = 1.d0 
       elseif(Ntaus.eq.1) then
         ltaus(1, 3) = itauMDE(100)      ! lepton  mode
         curBRA = brLEP
       elseif(Ntaus.eq.2) then
         ltaus(1, 3) = itauMDE(100)      ! lepton  mode
         ltaus(2, 3) = 3 - ltaus(1, 3)
         curBRA = gamprt(1) * gamprt(2) 
       elseif(Ntaus.ge.3) then
        ist1 = ( Ntaus    * pyr(0)) + 1
        ist2 = ((Ntaus-1) * pyr(0)) + 1 
        if(ist2.eq.ist1) ist2 = ist2 + 1
       ltaus(ist1,3) = itauMDE(100) 
       ltaus(ist2,3) = 3 - ltaus(ist1, 3) 
         curBRA = gamprt(1) * gamprt(2) 
         do idir = 1, Ntaus
          if(idir.ne.ist1.AND.idir.ne.ist2) then
            ltaus(idir,3) = itauMDE(200) 
            curBRA = curBRA * brHAD 
          endif
         enddo 
       endif
*
      ELSEIF(mdtau.eq.230) THEN   ! only hadronic modes for any tau 
       curBRA = 1.d0
       do idir = 1, Ntaus
        ltaus(idir,3) = itauMDE(200) 
        curBRA = curBRA * brHAD
       enddo
*
      ELSEIF(mdtau.eq.231) THEN    ! ONE tau -> hadrons 
       curBRA = 1.d0               ! other taus -> all channels
       if(Ntaus.eq.1) then
         ltaus(1,3) = itauMDE(200)
         curBRA = brHAD
       elseif(Ntaus.ge.2) then
        ist1 = ( Ntaus    * pyr(0)) + 1
        ltaus(ist1,3) = itauMDE(200)
        curBRA = brHAD
      endif
*
      ELSEIF(mdtau.eq.232) THEN    ! TWO taus -> hadrons 
       curBRA = 1.d0               ! other taus -> all channels
       if(Ntaus.eq.1) then
          ltaus(1,3) = itauMDE(200)
          curBRA = brHAD
       elseif(Ntaus.eq.2) then
          ltaus(1,3) = itauMDE(200)
          ltaus(2,3) = itauMDE(200)
          curBRA = brHAD**2
       elseif(Ntaus.ge.3) then
        ist1 = ( Ntaus    * pyr(0)) + 1
        ist2 = ((Ntaus-1) * pyr(0)) + 1 
        if(ist2.eq.ist1) ist2 = ist2 + 1
        ltaus(ist1,3) = itauMDE(200)
        ltaus(ist2,3) = itauMDE(200)
        curBRA = brHAD**2 
      endif
*
      ELSEIF(mdtau.eq.240) THEN      ! only (nutau + PI+-) for any tau 
       curBRA = 1.d0
       do idir = 1, Ntaus 
        ltaus(idir,3) = 3 
        curBRA = curBRA * gamprt(3)
       enddo
*
      ELSEIF(mdtau.eq.241) THEN      ! ONE tau -> (nutau + PI+-) 
       curBRA = 1.d0                 ! other taus -> all channels
       if(Ntaus.eq.1) then
         ltaus(1,3) = 3
         curBRA = gamprt(3) 
       elseif(Ntaus.ge.2) then
         ist1 = ( Ntaus    * pyr(0)) + 1
         ltaus(ist1,3) = 3
         curBRA = gamprt(3)
      endif
*
      ELSEIF(mdtau.eq.242) THEN     ! TWO taus -> (nutau + PI+-)taus
       curBRA = 1.d0                ! other taus -> all channels
       if(Ntaus.eq.1) then
         ltaus(1,3) = 3
         curBRA = gamprt(3)
       elseif(Ntaus.eq.2) then
         ltaus(1,3) = 3
         ltaus(2,3) = 3
         curBRA = gamprt(3)**2
       elseif(Ntaus.ge.3) then
         ist1 = ( Ntaus    * pyr(0)) + 1
         ist2 = ((Ntaus-1) * pyr(0)) + 1 
         if(ist2.eq.ist1) ist2 = ist2 + 1
         ltaus(ist1,3) = 3
         ltaus(ist2,3) = 3
         curBRA = gamprt(3)**2
      endif
*
      ENDIF 
*
      return         
      END
