*----------------------------------------------------------------------------*
* modified by Serge Slabospitsky  08.12.2005                                 *
* PRETAUOLA.05  version for TAUOLA usage with PYTHIA                         *      
*                                                                            *
* TAUOLA UNIVERSAL INTERFACE: VERSION 1.21, September 2005                   *
*                                                                            *
*----------------------------------------------------------------------------*

      SUBROUTINE TAUOLA_SRS(MODE,KEYPOL) 
C      SUBROUTINE TAUOLA(MODE,KEYPOL) 
C     *************************************
C general tauola interface, should work in every case until 
C hepevt is OK, does not check if hepevt is 'clean'
C in particular will decay decayed taus...
C only longitudinal spin effects are included.
C in W decay v-a vertex is assumed
C date: 12 DEC 1998. date: 21 June 1999. date: 24 Jan 2001 date: 24 Aug 2001
      implicit none 
#include "hepevt.inc"
*      INTEGER NMXHEP
*      PARAMETER (NMXHEP=4000)
*      double precision phep,  vhep ! to be real*4/ *8  depending on host
*      INTEGER nevhep,nhep,isthep,idhep,jmohep,
*     $        jdahep
*      COMMON /hepevt_t/
*     $      nevhep,               ! serial number
*     $      nhep,                 ! number of particles
*     $      isthep(nmxhep),   ! status code
*     $      idhep(nmxhep),    ! particle ident KF
*     $      jmohep(2,nmxhep), ! parent particles
*     $      jdahep(2,nmxhep), ! childreen particles
*     $      phep(5,nmxhep),   ! four-momentum, mass [GeV]
*     $      vhep(4,nmxhep)    ! vertex [mm]
* ----------------------------------------------------------------------
      LOGICAL qedrad
      COMMON /phoqed/ 
     $     qedrad(nmxhep)    ! Photos flag
* ----------------------------------------------------------------------
      SAVE /phoqed/
*      SAVE /hepevt_t/, /phoqed/
*
      INTEGER NP1, NP2
      COMMON /TAUPOS/ NP1, NP2 
*      REAL*4 PHOI(4),PHOF(4)
      double precision Q1(4),Q2(4),P1(4),P2(4),P3(4),P4(4)
      COMMON / MOMDEC / Q1,Q2,P1,P2,P3,P4
* tauola, photos and jetset overall switches
      integer JAK1,JAK2,ITDKRC,IFPHOT,IFHADM,IFHADP  ! srs
      COMMON /LIBRA/ JAK1,JAK2,ITDKRC,IFPHOT,IFHADM,IFHADP
* srs
      integer njak1, njak2, JAKP,JAKM,KTOM           ! srs
      COMMON / JAKI   /  NJAK1,NJAK2,JAKP,JAKM,KTOM  ! srs 
* srs
      REAL*4 RRR(1)
      LOGICAL IFPSEUDO
      double precision psi, xmtau, xmh, betah
      REAL*4 csc,ssc
      common /pseudocoup/ csc,ssc
      save /pseudocoup/
*      save pseudocoup  ! srs
      integer          INUT,IOUT
      COMMON / INOUT / INUT,IOUT

C to switch tau polarization OFF in taus 
*      DIMENSION POL1(4), POL2(4)
      real POL1(4), POL2(4)
      double precision POL1x(4)   !, POL2x(4)
      INTEGER ION(3)
      DATA  POL1 /0.0,0.0,0.0,0.0/
      DATA  POL2 /0.0,0.0,0.0,0.0/
      double precision PI
      DATA PI /3.141592653589793238462643D0/

C store decay vertexes 
      integer IMOTHER (20)
      INTEGER KFHIGGS(3)
* srs
      integer            PJAK1, PJAK2, MDTAU  ! srs
      common /ki_taumod/ PJAK1, PJAK2, MDTAU  ! srs
      integer j23  
* srs
C store daughter pointers
      INTEGER ISON
      COMMON /ISONS_TAU/ISON(2)
      SAVE /ISONS_TAU/
      integer mode, keypol, isel, IM, IM0, NCOUNT, JMOTH, J, I, IMOTH,
     & NDEC, II, Nstop, Nstart, KFnue, KFtau, KFgam, KFz0, KFhigch 
      double precision PLZAPX, POL
      real polz0
* srs
      integer ntaumax,  ntaus, ltaus 
      parameter  (ntaumax=50)
      common  /taulist/ ntaus, ltaus(ntaumax,3)
*  ltaus(i, 1) position, ltaus(i, 2) KF code, ltaus(i,3) decay channel
*  srs
* 
*------------
      IF(MODE.EQ.-1) THEN
C     ***********************

         JAK1  =  PJAK1      ! decay mode first tau 
         JAK2  =  PJAK2      ! decay mode second tau
*         JAK1  =  0     ! decay mode first tau 
*         JAK2  =  0     ! decay mode second tau
         ITDKRC=1.0     ! switch of radiative corrections in decay
         IFPHOT=1.0     ! PHOTOS switch
         IFHADM=1.0
         IFHADP=1.0
         POL=1.d0        ! tau polarization dipswitch must be 1 or 0

         KFHIGGS(1) = 25
         KFHIGGS(2) = 35
         KFHIGGS(3) = 36
         KFHIGCH = 37
         KFZ0    = 23
         KFGAM   = 22
         KFTAU   = 15
         KFNUE   = 16
C couplings of the 'pseudoscalar higgs' as in CERN-TH/2003-166
         psi=0.5*PI ! 0.15*PI
         xmtau=1.777 ! tau mass
         xmh=120     ! higgs boson mass
         betah=dsqrt(1d0-4*xmtau**2/xmh**2)
         csc=real(dcos(psi)*betah)
         ssc=real(sin(psi))
C         write(*,*) ' scalar component=',csc,' pseudo-scalar component=',ssc


         IF (IFPHOT.EQ.1) CALL  PHOINI !this if PHOTOS was not init.  earlier
         CALL  INIETC(JAK1,JAK2,ITDKRC,IFPHOT)
         CALL  INIMAS
         CALL  INIPHX(0.01d0)
         CALL  INITDK
C activation of pi0 and eta decays: (1) means on,  (0) off
         ION(1)=0
         ION(2)=0
         ION(3)=0
         CALL  TAUPI0(-1,1,ION)

         CALL DEKAY(-1,POL1x)
         WRITE(IOUT,7001) pol,psi,ION(1),ION(2),ION(3)
        call taurep(mode)    ! srs  initializatio

      ELSEIF(MODE.EQ.0) THEN
C     ***********************
C
C..... find tau-s and fill common block /TAUPOS/
C this is to avoid LUND history fillings. This call is optional
      CALL PHYFIX(NSTOP,NSTART)
C clear mothers of the previous event

      DO II=1,20
       IMOTHER(II)=0
      ENDDO

      DO II=1,2
         ISON(II)=0
      ENDDO
C ... and to find mothers giving taus.
* srs
       do II = 1, ntaumax
        ltaus(II, 1) = 0
        ltaus(II, 2) = -1
        ltaus(II, 3) = -1 
       enddo
      ntaus   = 0
* srs
      NDEC    = 0
C(BPK)--> LOOK FOR MOTHER, CHECK THAT IT IS NOT THE HISTORY ENTRY (E.G. MSTP(128)=0)
      DO I=NSTART,NHEP
        IF(ABS(IDHEP(I)).EQ.KFTAU.AND.ISTHEP(I).EQ.1.AND.
     $        (ISTHEP(I).GE.125.OR.ISTHEP(I).LT.120)) THEN
* srs
           ntaus = ntaus + 1
           ltaus(ntaus,1) = I
           ltaus(ntaus,2) = Idhep(i)
* srs
           IMOTH=JMOHEP(1,I)
           DO WHILE (ABS(IDHEP(IMOTH)).EQ.KFTAU) ! KEEP WALKING UP
              IMOTH=JMOHEP(1,IMOTH)
           ENDDO
           IF (ISTHEP(IMOTH).EQ.3.OR.
     $        (ISTHEP(IMOTH).GE.120.AND.ISTHEP(IMOTH).LE.125)) THEN 
              DO J=NSTART,NHEP  ! WE HAVE WALKED INTO HARD RECORD
                 IF (IDHEP(J).EQ.IDHEP(IMOTH).AND.
     $               JMOHEP(1,J).EQ.IMOTH.AND.
     $               ISTHEP(J).EQ.2) THEN
                    JMOTH=J
                    GOTO 66
                 ENDIF
              ENDDO
           ELSE
              JMOTH=IMOTH
           ENDIF
 66        CONTINUE
           DO II=1,NDEC
            IF(JMOTH.EQ.IMOTHER(II)) GOTO 9999
           ENDDO
           NDEC=NDEC+1
           IMOTHER(NDEC)= JMOTH
        ENDIF
 9999   CONTINUE
      ENDDO  
*   srs
       if(ntaus.le.0.or.ndec.le.0) then
         call taurep(mode)   ! srs  calculate total BR
         return
       endif
       call taudec   ! set specific decay channels,  by SRS
*   srs
C ... taus of every mother are treated in this main loop
      DO II=1,NDEC
         IM=IMOTHER(II)
         NCOUNT=0
         NP1=0
         NP2=0

C(BPK)--> 
C CORRECTING HEPEVT IS OUT OF QUESTION AT THIS POINT..
         IM0=IM
         IF (IDHEP(JMOHEP(1,IM0)).EQ.IDHEP(IM0)) IM0=JMOHEP(1,IM0)
         ISEL=-1
*         DO I=NSTART,NHEP
         DO I=(max(NSTART,IM0)), NHEP   ! srs
            IF (ISTHEP(I).EQ.3.OR.
     $           (ISTHEP(I).GE.120.AND.ISTHEP(I).LE.125)) THEN ! HARD RECORD
               GOTO 76
            ENDIF
            IMOTH=JMOHEP(1,I)
*             if(IMOTH.eq.0) call pylist(2)
            DO WHILE (IDHEP(IMOTH).EQ.IDHEP(I).OR.
     & ABS(IDHEP(IMOTH)).EQ.KFTAU) ! KEEP WALKING UP
               IMOTH=JMOHEP(1,IMOTH)
              if(IMOTH.eq.0) then      ! srs
               if(ison(1).ne.0.AND.ison(2).ne.0) goto 777
              goto 76                  ! srs 
              endif                    ! srs
            ENDDO
 777          continue                 ! srs
            IF ((IMOTH.EQ.IM0.OR.IMOTH.EQ.IM).AND.ISEL.EQ.-1) THEN
               ISON(1)=I
               ISEL=0
            ELSEIF ((IMOTH.EQ.IM0.OR.IMOTH.EQ.IM).AND.ISEL.EQ.0) THEN
               ISON(2)=I
            ELSEIF ((IMOTH.NE.IM0.AND.IMOTH.NE.IM).AND.ISEL.EQ.0) THEN
               ISEL=1
               GOTO 77
            ENDIF
 76         CONTINUE
         ENDDO
 77      CONTINUE
C(BPK)--< 
*
C ... we check whether there are just two or more tau-likes 
         DO I=ISON(1),ISON(2)
            IF(IDHEP(I).EQ.-KFTAU.OR.IDHEP(I).EQ.-KFNUE) NCOUNT=NCOUNT+1
            IF(IDHEP(I).EQ. KFTAU.OR.IDHEP(I).EQ. KFNUE) NCOUNT=NCOUNT+1
         ENDDO

C ... if there will be more we will come here again
 666     CONTINUE

C(BPK)--> 
         DO I=MAX(NP1+1,ISON(1)),ISON(2) 
C(BPK)--< 
            IF(IDHEP(I).EQ.-KFTAU.OR.IDHEP(I).EQ.-KFNUE) NP1=I
         ENDDO
C(BPK)--> 
         DO I=MAX(NP2+1,ISON(1)),ISON(2)
C(BPK)--< 
            IF(IDHEP(I).EQ. KFTAU.OR.IDHEP(I).EQ. KFNUE) NP2=I
         ENDDO
         DO I=1,4
            P1(I)= PHEP(I,NP1)    !momentum of tau+
            P2(I)= PHEP(I,NP2)    !momentum of tau-
            Q1(I)= P1(I)+P2(I)
         ENDDO
*
          njak1 = -1
          njak2 = -1
         do j23 = 1,ntaus
          if(ltaus(j23,1).eq.NP1) njak1 = ltaus(j23,3) 
          if(ltaus(j23,1).eq.NP2) njak2 = ltaus(j23,3) 
         enddo

         POL1(3)=  0D0
         POL2(3)=  0D0
         
         IF(KEYPOL.EQ.1) THEN
c.....include polarisation effect
         CALL RANMAR(RRR,1)

         IF(IDHEP(IM).EQ.KFHIGGS(1).OR.IDHEP(IM).EQ.KFHIGGS(2).OR.
     $    IDHEP(IM).EQ.KFHIGGS(3)) THEN   ! case of Higgs 
            IF(RRR(1).LT.0.5) THEN
               POL1(3)= POL
               POL2(3)=-POL
            ELSE     
               POL1(3)=-POL
               POL2(3)= POL
            ENDIF
         ELSEIF((IDHEP(IM).EQ.KFZ0).OR.(IDHEP(IM).EQ.KFGAM)) THEN 
*                                          ! case of gamma/Z 
C there is no angular dependence in gamma/Z polarization 
C there is no s-dependence in gamma/Z polarization at all
C there is even no Z polarization in any form
C main reason is that nobody asked ...
C but it is prepared and longitudinal correlations 
C can be included up to KORALZ standards

            POLZ0=PLZAPX(.true.,IM,NP1,NP2)
            IF(RRR(1).LT.POLZ0) THEN
               POL1(3)= POL
               POL2(3)= POL
            ELSE     
               POL1(3)=-POL
               POL2(3)=-POL
            ENDIF
         ELSEIF(IDHEP(NP1).EQ.-IDHEP(NP2))THEN ! undef orig. only s-dep poss.
            POLZ0=PLZAPX(.true.,IM,NP1,NP2)
            IF(RRR(1).LT.POLZ0) THEN
               POL1(3)= POL
               POL2(3)= POL
            ELSE     
               POL1(3)=-POL
               POL2(3)=-POL
            ENDIF
         ELSEIF(ABS(IDHEP(IM)).EQ.KFHIGCH) THEN ! case of charged Higgs 
            POL1(3)=  POL
            POL2(3)=  POL
         ELSE ! case of W+ or W-
            POL1(3)= -POL
            POL2(3)= -POL
         ENDIF
c.....include polarisation effect
         ENDIF  

         IF(IDHEP(IM).EQ.KFHIGGS(1).OR.IDHEP(IM).EQ.KFHIGGS(2).OR.
     $   IDHEP(IM).EQ.KFHIGGS(3)) THEN
           IF(IDHEP(NP1).EQ.-KFTAU                           .AND.
     $       (JDAHEP(1,NP1).LE.NP1.OR.JDAHEP(1,NP1).GT.NHEP) .AND.
     $        IDHEP(NP2).EQ. KFTAU                            .AND.
     $       (JDAHEP(1,NP2).LE.NP2.OR.JDAHEP(1,NP2).GT.NHEP)
     $                                                       ) THEN
               IF     (IDHEP(IM).EQ.KFHIGGS(1)) THEN
                 IFPSEUDO= .FALSE.
               ELSEIF (IDHEP(IM).EQ.KFHIGGS(2)) THEN
                 IFPSEUDO= .FALSE.
               ELSEIF (IDHEP(IM).EQ.KFHIGGS(3)) THEN
                 IFPSEUDO= .TRUE.
               ELSE
                 WRITE(*,*) 'Warning from TAUOLA:'
                 WRITE(*,*) 'I stop this run, wrong IDHEP(IM)=',
     &IDHEP(IM)
                 STOP
             ENDIF
             CALL SPINHIGGS(IM,NP1,NP2,IFPSEUDO,Pol1,Pol2)
            IF (IFPHOT.EQ.1) CALL PHOTOS(IM)  ! Bremsstrahlung in Higgs decay
                                              ! AFTER adding taus !!

           ENDIF
         ELSE
           IF(IDHEP(NP1).EQ.-KFTAU.AND.
     $       (JDAHEP(1,NP1).LE.NP1.OR.JDAHEP(1,NP1).GT.NHEP)) THEN
C            here check on if NP1 was not decayed should be verified
             CALL DEXAY(1,POL1)
             IF (IFPHOT.EQ.1) CALL PHOTOS(NP1)
             CALL TAUPI0(0,1,ION)
           ENDIF

           IF(IDHEP(NP2).EQ. KFTAU.AND.
     $       (JDAHEP(1,NP2).LE.NP2.OR.JDAHEP(1,NP2).GT.NHEP)) THEN
C            here check on if NP2 was not decayed should be added
             CALL DEXAY(2,POL2)
             IF (IFPHOT.EQ.1) CALL PHOTOS(NP2)
             CALL TAUPI0(0,2,ION)
           ENDIF
         ENDIF
         NCOUNT=NCOUNT-2
         IF (NCOUNT.GT.0) GOTO 666
      ENDDO
      call taurep(mode)
      ELSEIF(MODE.EQ.1) THEN
C     ***********************
C
      call taurep(mode)   ! srs   write summary of BR
*      CALL DEXAY(100,POL1)
*      CALL DEKAY(100,POL1x)
           WRITE(IOUT,7002)
      ENDIF
C     *****
 7001 FORMAT(///1X,15(5H*****)
     $ /,' *',     25X,'*****TAUOLA UNIVERSAL INTERFACE: ******',9X,1H*,
     $ /,' *',     25X,'*****VERSION 1.21, September 2005******',9X,1H*,
     $ /,' *',     25X,'**AUTHORS: P. Golonka, B. Kersevan, ***',9X,1H*,
     $ /,' *',     25X,'**T. Pierzchala, E. Richter-Was, ******',9X,1H*,
     $ /,' *',     25X,'****** Z. Was, M. Worek ***************',9X,1H*,
     $ /,' *',     25X,'**USEFUL DISCUSSIONS, IN PARTICULAR ***',9X,1H*,
     $ /,' *',     25X,'*WITH C. Biscarat and S. Slabospitsky**',9X,1H*,
     $ /,' *',     25X,'****** are warmly acknowledged ********',9X,1H*,
     $ /,' *',     25X,'                                       ',9X,1H*,
     $ /,' *',     25X,'********** INITIALIZATION  ************',9X,1H*,
     $ /,' *',F20.5,5X,'tau polarization switch must be 1 or 0 ',9X,1H*,
     $ /,' *',F20.5,5X,'Higs scalar/pseudo mix CERN-TH/2003-166',9X,1H*,
     $ /,' *',I10, 15X,'PI0 decay switch must be 1 or 0        ',9X,1H*,
     $ /,' *',I10, 15X,'ETA decay switch must be 1 or 0        ',9X,1H*,
     $ /,' *',I10, 15X,'K0S decay switch must be 1 or 0        ',9X,1H*,
     $  /,1X,15(5H*****)/)

 7002 FORMAT(///1X,15(5H*****)
     $ /,' *',     25X,'*****TAUOLA UNIVERSAL INTERFACE: ******',9X,1H*,
     $ /,' *',     25X,'*****VERSION 1.21, September2005 ******',9X,1H*,
     $ /,' *',     25X,'**AUTHORS: P. Golonka, B. Kersevan, ***',9X,1H*,
     $ /,' *',     25X,'**T. Pierzchala, E. Richter-Was, ******',9X,1H*,
     $ /,' *',     25X,'****** Z. Was, M. Worek ***************',9X,1H*,
     $ /,' *',     25X,'**USEFUL DISCUSSIONS, IN PARTICULAR ***',9X,1H*,
     $ /,' *',     25X,'*WITH C. Biscarat and S. Slabospitsky**',9X,1H*,
     $ /,' *',     25X,'****** are warmly acknowledged ********',9X,1H*,
     $ /,' *',     25X,'****** END OF MODULE OPERATION ********',9X,1H*,
     $  /,1X,15(5H*****)/)

      END
